<?php
/*
 * options-timeline.php
 * Description: WordPress Admin options for the SIMILE Timline Plugin
 * Plugin URI: http://www.freshlabs.de/journal/archives/2006/10/wordpress-plugin-simile-timeline/
 * Author: Tim Isenheim
 * 
	===========================================================================
	SIMILE Timeline for WordPress
	Copyright (C) 2006 Tim Isenheim
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
	===========================================================================
*/
/* ---------------------------------------------------------------------------------
     This function saves user options selected in the Admin panel.
 * --------------------------------------------------------------------------------*/
function stl_update_options(){
	if(isset($_POST['stl_timeline_locale'])){
		update_option('stl_timeline_locale', $_POST['stl_timeline_locale']);
	}
	
	update_option('stl_timelinepageids', $_POST['stl_timelinepageids']);
	update_option('stl_timeline_showfutureposts', $_POST['stl_timeline_showfutureposts']);
     
	$stl_band_options_to_save = array();
	 
	$stl_heights_posted = $_POST['stl_timelineband_height'];
	$stl_units_posted = $_POST['stl_timelineband_unit'];
	$stl_intervals_posted = $_POST['stl_timelineband_interval'];
	$stl_bgcolors_posted = $_POST['stl_band_bgcolor'];
	$stl_intvcolors_posted = $_POST['stl_band_intvcolor'];
	$stl_labeloutcolors_posted = $_POST['stl_band_labeloutcolor'];
	$stl_labelincolors_posted = $_POST['stl_band_labelincolor'];
	$stl_show_bandlabels = $_POST['stl_band_showlabels'];
	 	
	$stl_band_options_to_save["heights"] = stl_push_post_array("heights", $stl_heights_posted);
	$stl_band_options_to_save["units"] = stl_push_post_array("units", $stl_units_posted);
	$stl_band_options_to_save["intervals"] = stl_push_post_array("intervals", $stl_intervals_posted);
	$stl_band_options_to_save["bgcolors"] = stl_push_post_array("bgcolors", $stl_bgcolors_posted);
	$stl_band_options_to_save["intvalinecolors"] = stl_push_post_array("intvalinecolors", $stl_intvcolors_posted);
	$stl_band_options_to_save["labeloutsidecolors"] = stl_push_post_array("labeloutsidecolors", $stl_labeloutcolors_posted);
	$stl_band_options_to_save["labelinsidecolors"] = stl_push_post_array("labelinsidecolors", $stl_labelincolors_posted);
	$stl_band_options_to_save["showbandlabels"] = stl_push_post_array("showbandlabels", $stl_show_bandlabels);
	
	update_option('stl_timeline_band_options', $stl_band_options_to_save);
	// Save timeline categories
	stl_edit_cats();
}

function stl_timeline_get_default_options(){
	$stl_default_options_bands = array(
		"heights"            => array("70%","30%","0%","0%"),
		"units"            => array("2","1","0","0"),
		"intervals"            => array("200","100","0","0"),
		"bgcolors"           => array("#eee","#ddd","#ccc","#aaa"),
		"intvalinecolors"    => array("#aaa","#aaa","#aaa","#aaa"),
		"labeloutsidecolors" => array("#000","#000","#000","#000"),
		"labelinsidecolors"  => array("#fff","#fff","#fff","#fff"),
		"showbandlabels"		=> array("on", "off", "off", "off")
	);
	return $stl_default_options_bands;
}

/* ---------------------------------------------------------------------------------
     Display User Options
 * --------------------------------------------------------------------------------*/
function stl_display_admin_page(){

	stl_upgrade();
	
	/* ---------------------------------------------------------------------------------
	     Check "stage" hidden form value and / or eventid in querystring to determine which type of Admin page to load.
	     If stage == process then we are updating the user options.
	 * --------------------------------------------------------------------------------*/
	if ('process' == $_POST['stage']){
	     stl_update_options();
	}
	$stl_timelinepageids = get_option('stl_timelinepageids');
	$stl_timeline_showfutureposts = get_option('stl_timeline_showfutureposts');
	$stl_timeline_locale = get_option('stl_timeline_locale');
	$stl_timeline_locales = array("en","es","fr","it","ru","se","vi","zh");
     
?>
	<div class="wrap">
	<h2><?php _e('SIMILE Timeline Options', 'stl_timeline') ?></h2>
		<form name="stl-options" method="post" action="<?php echo str_replace( '%7E', '~', $_SERVER['REQUEST_URI']); ?>&amp;updated=true">
		<?php wp_nonce_field('update-options'); ?>
			<input type="hidden" name="stage" value="process" />
		
<!--
******************************************************
Timeline Integration
******************************************************
-->	               
			<fieldset class="options">
			<h3>Timeline Integration</h3>
				<table width="90%" cellpadding="8" class="form-table">
				<tr valign="middle">
				<th scope="row"><?php _e('The simplest way:', 'stl_timeline') ?></th>
				<td width="350"><?php _e('Include the shortcode [similetimeline] in your post or page to create a timeline. Then start posting in the timelined categories.', 'stl_timeline'); ?></td>
				</tr>
				<tr valign="middle">
				<th scope="row"><?php _e('Pages with a timeline:', 'stl_timeline') ?><br /><small><?php _e('Enter the page or post IDs, seperated by comma. Set to 0 or all to include the Timeline script on all pages (default).', 'stl_timeline'); ?></small></th>
				<td><input name="stl_timelinepageids" type="text" id="stl_timelinepageids" value="<?php echo $stl_timelinepageids; ?>" size="30" />
				</td>
				</tr>
				
				<tr valign="middle">
				<th scope="row"><?php _e('Display future posts', 'stl_timeline') ?>:<br /><small><?php _e('Select this option if you want to show future posts in the timeline.', 'stl_timeline'); ?></small></th>
				<td>
				<fieldset>
				<label for="stl_timeline_showfutureposts">
				<input name="stl_timeline_showfutureposts" id="stl_timeline_showfutureposts" value="1" type="checkbox"<?php if($stl_timeline_showfutureposts==1) echo ' checked="checked" '; ?> />
				<?php _e('Display future posts', 'stl_timeline'); ?></label><br>
				</fieldset>
				</td>
				</tr>
				
				<tr valign="middle">
				<th width="50%" scope="row"><?php _e('Localization:', 'stl_timeline') ?><br /><small><?php _e('Timeline language. Still partially implemented at SIMILE.', 'stl_timeline'); ?></small></th>
				<td>
					<select name="stl_timeline_locale" id="stl_timeline_locale" style="width: 200px;">
					<?php foreach($stl_timeline_locales as $stl_locale) { ?>
						<option value="<?php echo($stl_locale); ?>"<?php selected($stl_locale, $stl_timeline_locale); ?>><?php echo($stl_locale); ?></option>
					<?php } ?>
					</select>				
				</td>
				</tr>
				
				</table>
				<p class="submit"><input type="submit" name="Submit" value="<?php _e('Update Options', 'stl_timeline') ?> &raquo;" /></p>
			</fieldset>

<!--
******************************************************
Timeline Appearance
******************************************************
-->		
			<fieldset class="options">
			<h3><?php _e('Timeline Appearance', 'stl_timeline'); ?></h3>
				
				<table width="100%" cellpadding="5" class="editform">
				<tr>
				<td width="50%" valign="top">
				<fieldset class="options">
				<h4><?php _e('Upper Band', 'stl_timeline'); ?></h4>
				<?php stl_output_options_for_band(0); ?>
				</fieldset>
				</td>
				<td width="50%" valign="top">
				<fieldset class="options">
				<h4><?php _e('Lower Band', 'stl_timeline'); ?></h4>
				<?php stl_output_options_for_band(1); ?>
				</fieldset>
				</td>
				</tr>
				</table>

				
				<p class="submit"><input type="submit" name="Submit" value="<?php _e('Update Options', 'stl_timeline') ?> &raquo;" /></p>
			</fieldset>

<!--
******************************************************
Timeline Categories
******************************************************
-->
			<fieldset class="options">
			<h3><?php _e('Timeline Categories', 'stl_timeline'); ?></h3>
				<p><small><?php printf(__('Select the categories the %s should process.','stl_timeline'), '<a href="http://simile.mit.edu/timeline/">' .__('SIMILE Timeline','stl_timeline') .'</a>' ); ?></small></p>
				<div id="colorPickerDiv" style="z-index: 100;background:#eee;border:1px solid #ccc;position:absolute;visibility:hidden;"> </div>
				<?php stl_timeline_categories('category'); ?>
				<p class="submit"><input type="submit" name="Submit" value="<?php _e('Update Options', 'stl_timeline') ?> &raquo;" /></p>
				
			</fieldset>
			
			<fieldset class="options">
			<h3><?php _e('Timeline Link Categories', 'stl_timeline'); ?></h3>
				<p><small><?php printf(__('Select the link-categories that hold your desired RSS links. The %s will process the feed content.','stl_timeline'), '<a href="http://simile.mit.edu/timeline/">' .__('SIMILE Timeline','stl_timeline') .'</a>' ); ?></small></p>
				<div id="colorPickerDiv" style="z-index: 100;background:#eee;border:1px solid #ccc;position:absolute;visibility:hidden;"> </div>
				<?php stl_timeline_categories('link_category'); ?>
				<p class="submit"><input type="submit" name="Submit" value="<?php _e('Update Options', 'stl_timeline') ?> &raquo;" /></p>
				
			</fieldset>
			

		</form>
	</div>
<?php
}

/* ---------------------------------------------------------------------------------
 * set categories to display in the timeline
 * --------------------------------------------------------------------------------*/
function stl_timeline_categories($term_type='category') {

    global $wpdb;
    global $cat_timeline;
	global $wp_roles;

	if ( current_user_can('manage_categories') ) {	?>

	<table width="100%" cellpadding="3" cellspacing="3" class="widefat">
		<thead>
	        <tr>
	        <th scope="col" style="width:120px;text-align:center;"><?php _e('Show in Timeline?', 'stl_timeline') ?></th> 
	        <th scope="col" style="width:60px;"><?php _e('ID', 'stl_timeline') ?></th>
	        <th scope="col" align="left" class="row-title"><?php _e('Name', 'stl_timeline') ?></th>
	        <th scope="col" width="130" align="center"><?php _e('Color', 'stl_timeline') ?></th>
	        </tr>
	    </thead>
<?php stl_cat_rows($term_type); ?>
	</table>
	
<?php
	} 
}

/* ---------------------------------------------------------------------------------
 * output category ids, names and checkboxes
 * --------------------------------------------------------------------------------*/
function stl_cat_rows($term_type, $parent = 0, $level = 0, $categories = 0, $termdata=null) {

    global $wpdb, $class;
    global $cat_timeline;

	$table = $wpdb->prefix."stl_timeline_terms";
	// read categories from database if none is set in the parameter
	if(!$termdata){
		$terms = get_terms( $term_type );
	}
	else{
		$terms = $termdata;
	}

	if ($terms) {
		$index = 1;
		$i=0;
		foreach ($terms as $category) {
			if ($category->parent == $parent) {
				$category->name = wp_specialchars($category->name);
				$pad = str_repeat('&#8212; ', $level);
				$catid = $category->term_id;
				$cat = $wpdb->get_row("SELECT active, color FROM $table WHERE term_id = $catid;");
				if ( current_user_can('manage_categories') ) {
					if ($cat->active ) $catvis_timelined = 'checked="checked"'; else $catvis_timelined = "";
					$edit  = "<label for='timelined_" . $catid . "'>".__('enable', 'stl_timeline')."</label> <input name='stl-timelined[$catid]' id='timelined_" . $catid . "' class='edit' type='checkbox' $catvis_timelined />&nbsp;&nbsp;";
					
					$color = stl_colorpick_unit('stl-catcolor',$catid, 'pick'.$catid, $cat->color);
				} else
					$edit = '';
				$class = ('alternate' == $class) ? '' : 'alternate';
				echo "<tr class='$class'>";
				echo '<th style="text-align: center;" class="">'.$edit.'</th>';  // TODO: class="check-column"
				echo '<th scope="row">'.$category->term_id.'</th>';
				echo "<th class=\"row-title\">$pad ".$category->name."</th>
					<th style='text-align: center;'>$color</th>
					</tr>" . "\n";
				stl_cat_rows($term_type, $catid, $level + 1, $categories, $terms);
				$index += 2;
			}
			$i++;
		}
	} else {
		return false;
	}
}

/* ---------------------------------------------------------------------------------
 * build markup for colorpicker
 * --------------------------------------------------------------------------------*/
function stl_colorpick_unit($field, $id, $palette, $hexvalue){
	$onclick = 'onclick="cp.select(document.getElementById(\''.$field.'_'.$id.'\'), \''.$palette.'\');return false;" ';
	$attribs = 'style="background: '.$hexvalue.';" class="stl-colorfield" name="' . $palette . '" id="' . $palette .'"';
	$link = '<a href="#"' . $onclick . $attribs .'><span>Pick color</span></a>' . "\n";
	$input = '		<input type="text" class="stl-colorvalue" value="'.$hexvalue.'" size="7" id="' . $field . '_' . $id. '" name="' . $field . '['.$id.']" />';
	return $link . $input;
}

/* ---------------------------------------------------------------------------------
 * update categories that are display by the timeline
 * --------------------------------------------------------------------------------*/
function stl_edit_cats() {

    global $wpdb;
    global $cat_timeline;
    $categories='';

	if (!$categories)
		$categories = $wpdb->get_results("SELECT * FROM ".$wpdb->prefix."stl_timeline_terms");

	if ($categories) {
		$stl_cs = array();
		foreach ($categories as $category) {
			$active = 0;

			# save category color to database
			if (!empty($_POST["stl-catcolor"][$category->term_id])){
				stl_timeline_update_catcolor($category->term_id, $_POST["stl-catcolor"][$category->term_id]);
			}
			# save active state to database	
			if ( isset($_POST['stl-timelined'][$category->term_id])) {
				array_push($stl_cs, $category->term_id);
				// Update category active/inactive
				stl_timeline_update_catactive($category->term_id, 1);
			} else {
				stl_timeline_update_catactive($category->term_id, 0);
			}
		}
		// save categories to option table
		$stl_cs_string = implode(",", $stl_cs);
		update_option('stl_timelinecategories', $stl_cs_string);
	}
}

function __stl_active_select($index, $cmp){
	if($index == $cmp){
		$s = ' value="'.$index.'" selected="selected"';
	}
	else{
		$s = ' value="'.$index.'"';
	}
	return $s;
}


/* ---------------------------------------------------------------------------------
     Output option interface for Timeline bands
 * --------------------------------------------------------------------------------*/
function stl_output_options_for_band($band_id){
	$bandoptions = get_option('stl_timeline_band_options');
	$show_labels_checked = '';
	if($bandoptions["showbandlabels"][$band_id] == "on"):
		$show_labels_checked = 'checked="checked"';
	endif;
	?>
	<table width="100%" cellpadding="3" cellspacing="3">
		<tr class="alternate">
			<th><label><?php _e('Height in %', 'stl_timeline'); ?></label></th>
			<td><input name="<?php echo "stl_timelineband_height[$band_id]"; ?>" type="text" id="<?php echo "stl_timelineband_height_".$band_id; ?>" value="<?php echo $bandoptions["heights"][$band_id]; ?>" size="10" /></td>
		</tr>
		<tr>
			<th><label><?php _e('Resolution', 'stl-timeline'); ?></label></th>
			<td>
			<select name="<?php echo "stl_timelineband_unit[$band_id]"; ?>" type="text" id="<?php echo "stl_timelineband_unit_".$band_id; ?>">
			<option<?php echo __stl_active_select(5, $bandoptions["units"][$band_id]); ?>><?php _e('Hour', 'stl_timeline'); ?></option>
			<option<?php echo __stl_active_select(4, $bandoptions["units"][$band_id]); ?>><?php _e('Day', 'stl_timeline'); ?></option>
			<option<?php echo __stl_active_select(3, $bandoptions["units"][$band_id]); ?>><?php _e('Week', 'stl_timeline'); ?></option>
			<option<?php echo __stl_active_select(2, $bandoptions["units"][$band_id]); ?>><?php _e('Month', 'stl_timeline'); ?></option>
			<option<?php echo __stl_active_select(1, $bandoptions["units"][$band_id]); ?>><?php _e('Year', 'stl_timeline'); ?></option>
			</select>
			</td>
		</tr>
		<tr class="alternate">
			<th><label><?php _e('Interval size', 'stl-timeline'); ?></label></th>
			<td><input name="<?php echo "stl_timelineband_interval[$band_id]"; ?>" type="text" id="<?php echo "stl_timelineband_interval_".$band_id; ?>" value="<?php echo $bandoptions["intervals"][$band_id]; ?>" size="10" /> px</td>
		</tr>
		<tr>
			<th><label><?php _e('Background color', 'stl_timeline'); ?></label></th>
			<td><?php echo stl_colorpick_unit('stl_band_bgcolor',$band_id,'stl_band'.$band_id.'_cp_bg',$bandoptions["bgcolors"][$band_id]); ?></td></tr>
		<tr class="alternate">
			<th><label><?php _e('Interval line color', 'stl_timeline'); ?></label></th>
			<td><?php echo stl_colorpick_unit('stl_band_intvcolor',$band_id,'stl_band'.$band_id.'_cp_intline',$bandoptions["intvalinecolors"][$band_id]); ?></td></tr>
		<tr>
			<th><label><?php _e('Label outside color', 'stl_timeline'); ?></label></th>
			<td><?php echo stl_colorpick_unit('stl_band_labeloutcolor',$band_id,'stl_band'.$band_id.'_cp_labelout',''.$bandoptions["labeloutsidecolors"][$band_id].''); ?></td>
		</tr>
		<tr class="alternate">
			<th><label><?php _e('Label inside color', 'stl_timeline'); ?></label></th>
			<td><?php echo stl_colorpick_unit('stl_band_labelincolor',$band_id,'stl_band'.$band_id.'_cp_labelin',''.$bandoptions["labelinsidecolors"][$band_id].''); ?></td>
		</tr>
		<tr>
			<th><label for="<?php echo "stl_band_showlabels_".$band_id; ?>"><?php _e('Show Labels', 'stl_timeline'); ?></label></th>
			<td><input type="checkbox" name="<?php echo "stl_band_showlabels[$band_id]"; ?>" id="<?php echo "stl_band_showlabels_".$band_id; ?>" <?php echo $show_labels_checked; ?> /></td>
		</tr>
	</table>
<?php
}

/* ---------------------------------------------------------------------------------
     Push options from $_POST array in 2-D array element defined by $key
 * --------------------------------------------------------------------------------*/
function stl_push_post_array($key, $post_arr){
	$response = array();
	for($i=0; $i<sizeof($post_arr); $i++){
     	$bop = $post_arr[$i];
     	if(!empty($bop)){
     		$response[$i] = $bop;
     	}
     	else{
     		$default = get_option('stl_timeline_band_options');
     		$response[$i] = $default[$key][$i];
     	}
	}
     return $response;
}
?>